class ClassifyGameScene : public Scene {
public:
// ctors
	explicit ClassifyGameScene(int level);
// dtor
	virtual ~ClassifyGameScene();
// override methods
	virtual float timelimit() { return 5.0f; /* 0.0f = None */ }
// callbacks
	virtual void tick();
	virtual void draw(Painter &p);
	virtual void button(enum MouseButton btn, Point curpos, bool isdown);
	virtual void drag(enum MouseButton btn, Point curpos);
	//virtual void hover(Point curpos);
private:
// variables
	Point m_objpos[3];
	int m_objtype[3];
	bool m_objfalling[3];
	bool m_objlanded[3];
	std::pair<float, float> m_objv[3];
	int m_maxobj;
	int m_grabbingidx;
	Point m_objgraboff;
	int m_leftobjs;
	Point m_precurpos;

	PWAVEDATA m_wpick;
	PWAVEDATA m_wfall;
	PWAVEDATA m_wland;
	PWAVEDATA m_wgood;
	PWAVEDATA m_wbad;
	PWAVEDATA m_wclear;
};

class ClassifyGameSceneBuilder : public SceneBuilder {
public:
// override methods
	virtual LPCWSTR sceneName() { return L"ぶんべつしろ!"; }
	virtual Scene *newScene(int level) { return new ClassifyGameScene(level); }
	virtual bool isDevScene() { return false; }
};
