class FontEditorScene : public Scene {
public:
// ctors
	explicit FontEditorScene(int level);
// callbacks
	virtual void draw(Painter &p);
	virtual void button(enum MouseButton btn, Point curpos, bool isdown);
	virtual void wheel(Point curpos, float delta);
	virtual void drag(enum MouseButton btn, Point curpos);
	virtual void hover(Point curpos) { m_curpos = curpos; }
	virtual void key(UINT vk, bool isdown);
	virtual void moji(TCHAR ch);
private:
// variables
	Point m_curpos;

	int m_fecuridx;
	Point m_feoffset;
	wchar_t m_fechar;
	float m_femag;
	int m_codepointi;
	int m_copycodei;
	wchar_t m_copychar;

	int m_bgcodei;
	int m_bgindexi;
	wchar_t m_bgchars[4];

	Point m_offorg;
	bool m_showHandle;
	Point m_bgoffsets[4];
	Point m_bgofforgs[4];
	wchar_t m_samplebuf[256];
	int m_samplei;
	Point m_sampleoffset;
	Point m_samplemoveoff;
	Point m_realtlorg;
	bool m_showInfo;

	bool m_selecting;
	std::vector<unsigned int> m_selpoints;
	Point m_selstart;
	Point m_selmoveorg;

	int m_vibrateparam;

	int m_splitcodei;
	wchar_t m_splitchar;

	TCHAR m_lastch; // debug
};

class FontEditorSceneBuilder : public SceneBuilder {
public:
// override methods
	virtual LPCWSTR sceneName() { return L"FontEditor"; }
	virtual Scene *newScene(int level) { return new FontEditorScene(level); }
	virtual bool isDevScene() { return true; }
};
