class KillBossGameScene : public Scene {
public:
// ctors
	explicit KillBossGameScene(int level);
// dtor
	virtual ~KillBossGameScene();
// override methods
	virtual float timelimit() { return 5.0f; /* 0.0f = None */ }
// callbacks
	virtual void tick();
	virtual void draw(Painter &p);
	virtual void button(enum MouseButton btn, Point curpos, bool isdown);
	virtual void drag(enum MouseButton btn, Point curpos);
	virtual void hover(Point curpos);
private:
// variables
	wchar_t m_bossch;
	int m_bosslife;
	int m_maxbosslife;
	Point m_bosspos;
	Point m_bosstarget;
	std::vector<std::pair<Point, Point> > m_bossbullets;
	std::vector<std::pair<Point, Point> > m_mybullets;
	int m_myx;
	float m_pretargetsec;
	Point m_curpos;
	float m_prebossbulletsec;
	bool m_bosspomf;
	bool m_mypomf;
	float m_bossmovetime;

	bool m_ticked;

	PWAVEDATA m_wbgm;
	PWAVEDATA m_wbossbullet;
	PWAVEDATA m_wmybullet;
	PWAVEDATA m_wbomb;
// private functions
	void newBossTarget();
};

class KillBossGameSceneBuilder : public SceneBuilder {
public:
// override methods
	virtual LPCWSTR sceneName() { return L"ボスをたおせ!"; }
	virtual Scene *newScene(int level) { return new KillBossGameScene(level); }
	virtual bool isDevScene() { return false; }
};
