enum GameState {
	GS_PREGAME,
	GS_ZOOMINGUP,
	GS_GAMING,
	GS_ZOOMINGDOWN,
	GS_POSTGAME,
	GS_LEVELUP,
	GS_ENDGAME,
};

class MainGameScene : public Scene {
public:
// ctors
	explicit MainGameScene(int level);
// dtors
	~MainGameScene();
// callbacks
	virtual void tick();
	virtual void draw(Painter &p);
	virtual void button(enum MouseButton btn, Point curpos, bool isdown);
	virtual void drag(enum MouseButton btn, Point curpos);
	virtual void hover(Point curpos);
	virtual void key(UINT vk, bool isdown);
	virtual void moji(TCHAR ch);

private:
// variables
	int m_level;
	int m_stageno;
	int m_failed;
	SceneBuilder *m_builder;
	Scene *m_gamescene;
	enum GameState m_state;
	float m_statesec;
	float m_preticksec;
	float m_gamingFinSec;
	enum SceneResult m_prevresult;
	float m_deadlinesec;
	float m_prelimsec;
	bool m_limitover;

	PWAVEDATA m_ok;
	PWAVEDATA m_bad;
	PWAVEDATA m_pregame;
	PWAVEDATA m_levelup;
	PWAVEDATA m_endgame;
	PWAVEDATA m_tick;
	PWAVEDATA m_tock;
	PWAVEDATA m_bomb;
// internal functions
	void newstate(enum GameState state);
	void drawelevator(Painter &p, int frame);
};

class MainGameSceneBuilder : public SceneBuilder {
public:
// override methods
	virtual LPCWSTR sceneName() { return L"MainGameScene"; }
	virtual Scene *newScene(int level) { return new MainGameScene(level); }
	virtual bool isDevScene() { return true; }
};
