#include <tchar.h> // debug
#include <windows.h>

#include <vector>

#include "support.h"

#include "Scene.h"

SceneManager g_sceneManager;

void Scene::onButtonDown(enum MouseButton btn, Point curpos) {
	if(m_button != NONE) {
		return;
	}

	m_button = btn;

	button(btn, curpos, true);
}

void Scene::onButtonUp(enum MouseButton btn, Point curpos) {
	if(m_button == NONE || m_button != btn) {
		return;
	}

	button(btn, curpos, false);

	m_button = NONE;
}

void Scene::onMousemove(Point curpos) {
	if(m_button == NONE) {
		hover(curpos);
	} else {
		drag(m_button, curpos);
	}
}

void Scene::onMousewheel(Point curpos, float delta) {
	wheel(curpos, delta);
}

void Scene::onKey(UINT vk, BOOL isDown) {
	// ignore modifier and IME-related keys
	switch(vk) {
	case VK_CONTROL:
	case VK_LCONTROL:
	case VK_RCONTROL:
	case VK_SHIFT:
	case VK_LSHIFT:
	case VK_RSHIFT:
	case VK_MENU:
	case VK_LMENU:
	case VK_RMENU:
	case VK_LWIN:
	case VK_RWIN:
	case VK_PROCESSKEY:
		return;
	}

	if(isDown) {
		if(m_vk != 0) {
			return;
		}

		m_vk = vk;

		key(vk, true);
	} else { // up
		if(m_vk == 0 || m_vk != vk) {
			return;
		}

		key(vk, false);

		m_vk = 0;
	}
}
