class SelectorScene : public Scene {
public:
// ctors
	explicit SelectorScene(int level);
// callbacks
	virtual void draw(Painter &p);
	virtual void button(enum MouseButton btn, Point curpos, bool isdown);
	virtual void drag(enum MouseButton btn, Point curpos) { m_curpos = curpos; }
	virtual void hover(Point curpos) { m_curpos = curpos; }
	virtual void moji(TCHAR ch);
private:
// variables
	Point m_curpos;
	std::vector<SceneBuilder*> m_selectableBuilders;
	int m_level;
};

class SelectorSceneBuilder : public SceneBuilder {
public:
// override methods
	virtual LPCWSTR sceneName() { return L"Scene Selector"; }
	virtual Scene *newScene(int level) { return new SelectorScene(level); }
	virtual bool isDevScene() { return true; }
};
