class SwordGameScene : public Scene {
public:
// ctors
	explicit SwordGameScene(int level);
// dtor
	virtual ~SwordGameScene();
// override methods
	virtual float timelimit() { return 10.0f; /* 0.0f = None */ }
// callbacks
	virtual void tick();
	virtual void draw(Painter &p);
	virtual void button(enum MouseButton btn, Point curpos, bool isdown);
	//virtual void drag(enum MouseButton btn, Point curpos);
	//virtual void hover(Point curpos);
private:
// variables
	Point m_enemyupper;
	Point m_myupper;
	float m_enemyv;
	float m_myv;
	float m_enemyiaisec;
	float m_enemydelaysec;
	bool m_enemyslayed;
	bool m_myslayed;
	float m_nextthundersec;
	float m_bigthundersec;
	bool m_ticked;
	bool m_premature;
	float m_slaysec;
	float m_presec;

	PWAVEDATA m_wbgm;
	PWAVEDATA m_wbigthunder;
	PWAVEDATA m_wshortthunder;
	PWAVEDATA m_wiai;
	PWAVEDATA m_wslay;
};

class SwordGameSceneBuilder : public SceneBuilder {
public:
// override methods
	virtual LPCWSTR sceneName() { return L"しんけんしょうぶ!"; }
	virtual Scene *newScene(int level) { return new SwordGameScene(level); }
	virtual bool isDevScene() { return false; }
};
