#include <tchar.h>
#include <windows.h>

#include <stdio.h>

#include "support.h"

void die(LPCTSTR msg) {
	MessageBox(NULL, msg, _T("Fatal Error"), MB_ICONERROR | MB_OK);
	ExitProcess(1);
}

void debug(LPCTSTR fmt, ...) {
	TCHAR buf[1024]; // XXX: const! but this is for debug...
	va_list ap;
	va_start(ap, fmt);
	_vsntprintf(buf, _countof(buf), fmt, ap);
	va_end(ap);
	//OutputDebugString(buf);
	MessageBox(NULL, buf, _T("debug"), MB_OK);
}

// 0...n
int randp(int n) {
	return (int)(rand() / (float)RAND_MAX * n);
}

// -n...+n
int randnp(int n) {
	return randp(n * 2 + 1) - n;
}

// b...e
int randr(int b, int e) {
	return randp(e - b) + b;
}

float randrf(float b, float e) {
	return (rand() / (float)RAND_MAX * (e - b)) + b;
}

HRGN createEmptyRgn() {
	RGNDATA rgnd;

	rgnd.rdh.dwSize = sizeof(rgnd.rdh);
	rgnd.rdh.iType = RDH_RECTANGLES;
	rgnd.rdh.nCount = 0;
	rgnd.rdh.nRgnSize = 0; // unknown size
	rgnd.rdh.rcBound.left = 0;
	rgnd.rdh.rcBound.top = 0;
	rgnd.rdh.rcBound.right = 0;
	rgnd.rdh.rcBound.bottom = 0;

	return ExtCreateRegion(NULL, sizeof(rgnd.rdh)/*no Buffer[]*/, &rgnd);
}

int sgn(int n) {
	if(n < 0) {
		return -1;
	} else if(0 < n) {
		return 1;
	} else {
		return 0;
	}
}
