#include <tchar.h>
#include <windows.h>

#include "support.h" // for debug()
#include "zipfs/zipfs.h"
#include "wavemix/wavemix.h"

#include "Globals.h"

PWAVEDATA unzLoadWave(const char *fname) {
	PWAVEDATA pwd;

	long size;
	BYTE *data = unzReadWhole(g_unz, fname, &size);
	if(data == NULL) {
		debug(_T("unzLoadWave: unzReadWhole returns NULL; file not found?"));
	}
	pwd = wmMemoryWave(data, size);
	if(pwd == NULL) {
		debug(_T("unzLoadWave: wmMemoryWave returns NULL!"));
	}
	free(data);

	return pwd;
}
